/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domain.Invoice;
import domain.Manufacturer;
import domain.Product;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import transfer.RequestObject;
import transfer.ResponseObject;
import util.Operation;
import util.ResponseStatus;

/**
 *
 * @author student1
 */
public class Controller {

    private static Controller instance;
    private final Map<String, Object> map;
    private final Socket socket;
    private final ObjectOutputStream objectOutputStream;
    private final ObjectInputStream objectInputStream;

    private Controller() throws IOException {
        map = new HashMap<>();
        socket = new Socket("localhost", 9000);
        objectOutputStream = new ObjectOutputStream(socket.getOutputStream());
        objectInputStream = new ObjectInputStream(socket.getInputStream());
    }

    public static Controller getInstance() throws IOException {
        if (instance == null) {
            instance = new Controller();
        }

        return instance;
    }

    public void login(String username, String password) throws IOException, ClassNotFoundException, Exception {
        RequestObject requestObject = new RequestObject();
        requestObject.setOperation(Operation.OPERATION_LOGIN);
        Map<String, String> userMap = new HashMap<>();
        userMap.put("username", username);
        userMap.put("password", password);
        requestObject.setData(userMap);

        objectOutputStream.writeObject(requestObject);
        objectOutputStream.flush();
        //waiting response

        ResponseObject responseObject = (ResponseObject) objectInputStream.readObject();

        ResponseStatus status = responseObject.getStatus();
        if (status == ResponseStatus.SUCCESS) {
            map.put("user", responseObject.getData());
        } else {
            throw new Exception(responseObject.getErrorMessage());
        }
    }

    public List<Manufacturer> getAllManufacturers() throws IOException, ClassNotFoundException, Exception {
        RequestObject requestObject = new RequestObject();
        requestObject.setOperation(Operation.OPERATION_ALL_MANUFACTURES);

        objectOutputStream.writeObject(requestObject);
        objectOutputStream.flush();
        //waiting response
        ResponseObject responseObject = (ResponseObject) objectInputStream.readObject();

        ResponseStatus status = responseObject.getStatus();
        if (status == ResponseStatus.SUCCESS) {
            return (List<Manufacturer>) responseObject.getData();
        } else {
            throw new Exception(responseObject.getErrorMessage());
        }

    }

    public Product saveProduct(Product product) throws Exception {
        RequestObject requestObject = new RequestObject(Operation.OPERATION_SAVE_PRODUCT, product);
        objectOutputStream.writeObject(requestObject);
        ResponseObject responseObject = (ResponseObject) objectInputStream.readObject();
        if (responseObject.getStatus() == ResponseStatus.SUCCESS) {
            return (Product) responseObject.getData();
        }
        throw new Exception(responseObject.getErrorMessage());
    }

    public List<Product> getAllProducts() throws Exception {
        return null;
        //return serviceProduct.getAll();
    }

    public void setProduct(Product product) {
        map.put("current.product", product);
    }

    public Map getMap() {
        return map;
    }

    public Invoice saveInvoice(Invoice invoice) throws Exception {
        return null;
        //return serviceInvoice.save(invoice);
    }
}
